#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <unistd.h>
#include <iostream>
#include <vector>
#include<queue>
#include<algorithm>
using namespace std;

#include "common.h"
#include "marshal.h"
#include "update.h"


struct str
{
int x;
int y;
};

struct bfs{
  int x;
  int y;
  int pocet;
  
};

bool isNear(int,int);


Mapa mapa;
Stav stav;   // vzdy som hrac cislo 0
vector<Prikaz> prikazy;

vector<str> Pozemky_veze,Pozemky_ostatne;
int akoBudemUtocit;

int zberac=0,vezaSipy=0,labMucha=0,labMedved=0,spawn=0;

int pocty[30];
int ciestOkoloVeze(int,int);


int mapa_t[100][100];


static void spravBFS(const Mapa& mapa) {
  
  for(int i=0; i<=60; i++)
      for(int j=0; j<=60; j++)
	mapa_t[i][j]=-1;

  queue<bfs> Q;
  for (int y = 0; y < mapa.h; y++) for (int x = 0; x < mapa.w; x++) {
    if (mapa.zisti(x, y) == MAPA_CIEL) {
      Q.push({x,y,0});
      cerr<<x<<" "<<y<<" CIEL"<<endl;
     // dist[y * mapa.w + x] = 0;
    }
  }
  

  
  while (!Q.empty()) {
    bfs p = Q.front(); Q.pop();
 
    if(p.x<0 || p.y<0 || p.x>=mapa.w || p.y>=mapa.h || mapa.zisti(p.x,p.y)==MAPA_POZEMOK|| mapa.zisti(p.x,p.y)==MAPA_VODA) continue;
    mapa_t[p.x][p.y]=p.pocet;
    //cerr<<mapa_t[p.x][p.y]<<"\n";
    
    //if(mapa_t[p.x][p.y]==-1) continue;
    if(mapa_t[p.x+1][p.y]==-1)
      Q.push({p.x+1,p.y,p.pocet+1});
        if(mapa_t[p.x-1][p.y]==-1)
    Q.push({p.x-1,p.y,p.pocet+1});
        if(mapa_t[p.x][p.y+1]==-1)
    Q.push({p.x,p.y+1,p.pocet+1});
        if(mapa_t[p.x][p.y-1]==-1)
    Q.push({p.x,p.y-1,p.pocet+1});

      

    
  }
  
}


bool compareTowers(str a,str b){
return  ciestOkoloVeze(a.x,a.y)<ciestOkoloVeze(b.x,b.y);
  
  
}


// pomocna funkcia. volajte zo zistiTah(), napr.:
// if (!vykonaj(Prikaz::stavaj(10, 10, VEZA_LASER))) { /* zeby malo dreva? */ }
bool vykonaj(const Prikaz& p) {
  bool uspech = vykonajPrikaz(mapa, stav, 0, p);
  if (uspech) prikazy.push_back(p);   // potom to posleme serveru
  return uspech;
}



int vezaName(int x,int y){
  
for(auto it=stav.hraci.begin()->veze.begin(); it!=stav.hraci.begin()->veze.end(); it++)
  if(x==it->x && y==it->y)
    return it->typ;
  
  
  return -1;
}


vector<str> motivujuce(int x,int y){
  vector<str> V;
 for(int i=x-3; i<=x+3; i++)
   for(int j=y-3; j<=y+3; j++)
     if(vezaName(i,j)>=0)
       V.push_back({i,j});
  
  
  
  return V;
  
}

vector<str> nabojujuce(int x,int y){
  vector<str> V;
 for(int i=x-3; i<=x+3; i++)
   for(int j=y-3; j<=y+3; j++){
    int p=vezaName(i,j);
     if(p==9){
       V.push_back({i,j});
     
       //cerr<<"mam motivator\n";
    }
   }
  
  
  return V;
  
}


// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
  cerr<<"Look at my code, my code is amazing\n";
  srand(time(NULL) * getpid());
  akoBudemUtocit = rand() % UTOCNIK_POCET_TYPOV;
  
  
  
  spravBFS(mapa);
  
  for(int i=0; i<mapa.w; i++){
    for(int j=0; j<mapa.h; j++)
      cerr<<mapa_t[j][i]<<"\t";
    cerr<<"\n";
  }

for(int i=0; i<mapa.w; i++)
for(int j=0; j<=mapa.h; j++){

  //cerr<<isNear(i,j)<<endl;
  if(isNear(i,j)==true && mapa.zisti(i,j)==MAPA_POZEMOK){
str temp;
temp.x=i;
temp.y=j;

Pozemky_veze.push_back(temp);
//cerr<<i<<" "<<j<<" Pozemky\n";
}
else
{
if(mapa.zisti(i,j)==MAPA_POZEMOK)
{
str temp;
temp.x=i;
temp.y=j;
Pozemky_ostatne.push_back(temp);
//cerr<<i<<" "<<j<<" ostatne\n";
}

}
}

sort(Pozemky_veze.begin(),Pozemky_veze.end(),compareTowers);

for(int i=0; i<30; i++)
  pocty[i]=0;

}


int pocetVezi(int typ) {
  int result = 0;
  FOREACH(it, stav.hraci[0].veze) if (it->typ == typ) result++;
  return result;
}

bool isNear(int x,int y){
return !(mapa.zisti(x+1,y)!=MAPA_CESTA&&mapa.zisti(x-1,y)!=MAPA_CESTA&& 
mapa.zisti(x,y+1)!=MAPA_CESTA&&mapa.zisti(x,y-1)!=MAPA_CESTA);

};

bool isNearMotivator(int x,int y){
  
  return !(mapa.zisti(x+1,y)==VEZA_MOTIVATOR||mapa.zisti(x-1,y)==VEZA_MOTIVATOR||
mapa.zisti(x,y+1)==VEZA_MOTIVATOR||mapa.zisti(x,y-1)==VEZA_MOTIVATOR);
  
  
}

int ciestOkoloVeze(int x,int y){
  return (mapa.zisti(x+1,y)==MAPA_CESTA + mapa.zisti(x-1,y)==MAPA_CESTA + 
mapa.zisti(x,y+1)==MAPA_CESTA + mapa.zisti(x,y-1)==MAPA_CESTA);
  
}






// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat

void zistiTah() {
  
  if(spawn==0){
         if(vykonaj(Prikaz::buduj(Pozemky_ostatne.begin()->x, Pozemky_ostatne.begin()->y, rand()%5+10))){
       Pozemky_ostatne.erase(Pozemky_ostatne.begin());
spawn++;
  }
  }
 // int mojLab = VEZA_LAB_PRVY + akoBudemUtocit;
  //vzberiem rand policko ostatne a tam postavim zberac
  /*
  for(auto it=stav.hraci.begin()->veze.begin(); it!=stav.hraci.begin()->veze.end(); it++)
    if(it->typ==VEZA_NASAVAC){
      vector<str>V=nabojujuce(it->x,it->y);
      
//      for(auto it1=V.begin(); it1!=V.end(); it1++)
	//cerr<<it1->x<<" "<<it1->y<<"\n";
      //cerr<<"\n";
      /*
      int l=rand()%V.size();
      vector<str>::iterator po=V.begin()+l;
      int rx=po->x;
      int ry=po->y;
      for(auto it1=V.begin(); it1!=V.end(); it1++){
      //cerr<<"motivujem vezu na x,y"<<rx<<" "<<ry<<"\n";
      if(vykonaj(Prikaz::aktivuj(it->x, it->y, it1->x,it1->y)))
	cerr<<"Som nabojoval\n";
      }
    }
  
  
  for(auto it=stav.hraci.begin()->veze.begin(); it!=stav.hraci.begin()->veze.end(); it++)
    if(it->typ==VEZA_MOTIVATOR){
      vector<str>V=motivujuce(it->x,it->y);
      
//      for(auto it1=V.begin(); it1!=V.end(); it1++)
	//cerr<<it1->x<<" "<<it1->y<<"\n";
      //cerr<<"\n";
      /*
      int l=rand()%V.size();
      vector<str>::iterator po=V.begin()+l;
      int rx=po->x;
      int ry=po->y;
      for(auto it1=V.begin(); it1!=V.end(); it1++){
      //cerr<<"motivujem vezu na x,y"<<rx<<" "<<ry<<"\n";
      if(vykonaj(Prikaz::aktivuj(it->x, it->y, it1->x,it1->y)))
	cerr<<"Som motivoval\n";
      }
    }
  
  
  */
  
 // cerr<<zberac<<" "<<Pozemky_veze.size()<<" "<<Pozemky_ostatne.size()<<"\n";
if(zberac<4){
vector<str>::iterator it;
if(Pozemky_ostatne.size()>0){
it=Pozemky_ostatne.begin();
it+=rand()%Pozemky_ostatne.size();
//cerr<<"Budujem zberac - ";
 if(vykonaj(Prikaz::buduj(it->x, it->y, VEZA_ZBERAC))){
zberac++;
//cerr<<"usepesne\n";
Pozemky_ostatne.erase(it);
}
}
else{ 
  
it=Pozemky_veze.begin();
it+=rand()%Pozemky_veze.size();
 if(vykonaj(Prikaz::buduj(it->x, it->y, VEZA_ZBERAC))){
zberac++;
Pozemky_veze.erase(it);
}
}
}


if(zberac>=4 ){
  
  if(vezaSipy<5){
  vector<str>::iterator it;
  it=Pozemky_veze.begin();


 if(vykonaj(Prikaz::buduj(it->x, it->y, rand()%7))){
vezaSipy++;
Pozemky_veze.erase(it);

}
}
  
  
  
  if(vezaSipy>=5){
  /*  
    if(zberac==4)
     if(vykonaj(Prikaz::buduj(Pozemky_veze.begin()->x, Pozemky_veze.begin()->y, VEZA_ZBERAC))){
       Pozemky_veze.erase(Pozemky_veze.begin());
zberac++;
     }
    */ 
     if(zberac>=4){
if(labMucha<1){
vector<str>::iterator it;
if(Pozemky_ostatne.size()>0){
it=Pozemky_ostatne.begin();
it+=rand()%Pozemky_ostatne.size();

 if(vykonaj(Prikaz::buduj(it->x, it->y, VEZA_LAB_MUCHA))){
labMucha++;;
Pozemky_ostatne.erase(it);
}

}

else if(Pozemky_veze.size()>0){
it=Pozemky_veze.begin();
it+=rand()%Pozemky_veze.size();

 if(vykonaj(Prikaz::buduj(it->x, it->y, VEZA_LAB_MUCHA))){
labMucha++;;
Pozemky_veze.erase(it);
}

}

}

if(pocty[VEZA_LAB_MEDVED]<1){
vector<str>::iterator it;
if(Pozemky_ostatne.size()>0){
it=Pozemky_ostatne.begin();
it+=rand()%Pozemky_ostatne.size();

 if(vykonaj(Prikaz::buduj(it->x, it->y, VEZA_LAB_MEDVED))){
pocty[VEZA_LAB_MEDVED]++;;
Pozemky_ostatne.erase(it);
}

}

else if(Pozemky_veze.size()>0){
it=Pozemky_veze.begin();
it+=rand()%Pozemky_veze.size();

 if(vykonaj(Prikaz::buduj(it->x, it->y, VEZA_LAB_MEDVED))){
pocty[VEZA_LAB_MEDVED]++;;
Pozemky_veze.erase(it);
}

}

}

if(pocty[VEZA_LAB_VOSKA]<1){
vector<str>::iterator it;
if(Pozemky_ostatne.size()>0){
it=Pozemky_ostatne.begin();
it+=rand()%Pozemky_ostatne.size();

 if(vykonaj(Prikaz::buduj(it->x, it->y, VEZA_LAB_VOSKA))){
pocty[VEZA_LAB_VOSKA]++;;
Pozemky_ostatne.erase(it);
}

}

else if(Pozemky_veze.size()>0){
it=Pozemky_veze.begin();
it+=rand()%Pozemky_veze.size();

 if(vykonaj(Prikaz::buduj(it->x, it->y, VEZA_LAB_VOSKA))){
pocty[VEZA_LAB_VOSKA]++;;
Pozemky_veze.erase(it);
}

}

}

if(pocty[VEZA_LAB_SLIMAK]<1){
vector<str>::iterator it;
if(Pozemky_ostatne.size()>0){
it=Pozemky_ostatne.begin();
it+=rand()%Pozemky_ostatne.size();

 if(vykonaj(Prikaz::buduj(it->x, it->y, VEZA_LAB_SLIMAK))){
pocty[VEZA_LAB_SLIMAK]++;;
Pozemky_ostatne.erase(it);
}

}

else if(Pozemky_veze.size()>0){
it=Pozemky_veze.begin();
it+=rand()%Pozemky_veze.size();

 if(vykonaj(Prikaz::buduj(it->x, it->y, VEZA_LAB_SLIMAK))){
pocty[VEZA_LAB_SLIMAK]++;;
Pozemky_veze.erase(it);
}

}

}

if(pocty[VEZA_LAB_HUSENICA]<1){
vector<str>::iterator it;
if(Pozemky_ostatne.size()>0){
it=Pozemky_ostatne.begin();
it+=rand()%Pozemky_ostatne.size();

 if(vykonaj(Prikaz::buduj(it->x, it->y, VEZA_LAB_HUSENICA))){
pocty[VEZA_LAB_HUSENICA]++;;
Pozemky_ostatne.erase(it);
}

}

else if(Pozemky_veze.size()>0){
it=Pozemky_veze.begin();
it+=rand()%Pozemky_veze.size();

 if(vykonaj(Prikaz::buduj(it->x, it->y, VEZA_LAB_HUSENICA))){
pocty[VEZA_LAB_HUSENICA]++;;
Pozemky_veze.erase(it);
}
}
}

}


while(true){
 bool ok=0; 
    vector<str>::iterator it;
if(Pozemky_veze.size()==0) break;
    it=Pozemky_veze.begin();


vector<int>V;
for(int u=0; u<7; u++){
  V.push_back(u);
  V.push_back(u);
  
}
//V.push_back(9);
//V.push_back(8);
int k=rand()%14;
 if(vykonaj(Prikaz::buduj(it->x, it->y, *(V.begin()+k)))){
 cerr << "Som postavil\n";
Pozemky_veze.erase(it);
ok=1;
}

  


  break;
}


  }




}
/*
  while(vykonaj(Prikaz::buduj(rand()% mapa.w, 
rand()%mapa.h,rand()%6)) );
*/


  /*
  while (pocetVezi(mojLab) < 1) {
    if (!vykonaj(Prikaz::buduj(rand() % mapa.w, rand() % mapa.h, mojLab))) break;
  }
*/

  while (true) {

   // int naKoho = 1 + rand() % (mapa.pocetHracov-1);
    
    vector<int> H;
    int p=0;
    for(vector<Hrac>::iterator it=stav.hraci.begin()+1; it!=stav.hraci.end();it++){
     p++;
      if(it->umrel==false)
	H.push_back(p);
    }
    
    if(H.size()==0)break;
    vector<int>::iterator it=H.begin();
    int naKoho=rand()%H.size();
    it+=naKoho;
    
    
    
    vykonaj(Prikaz::utoc(*it, 1)) ;
        vykonaj(Prikaz::utoc(*it, 2)) ;
	    vykonaj(Prikaz::utoc(*it, 3)) ;
	        vykonaj(Prikaz::utoc(*it, 4)) ;
			        vykonaj(Prikaz::utoc(*it, 5)) ;
   // cerr << "Som zautocil\n";
break;
  }

  // hmm este nejaku obranu by to chcelo...
}


int main() {
  // v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

  nacitaj(cin, mapa);
  inicializuj();
  
  int body0 =0;

  while (cin.good()) {
    nacitaj(cin, stav);
    int body1 =stav.hraci.begin()->body;
    if(body1-body0 > 50) cerr << "Som zabil\n";
    body0 =body1;
    prikazy.clear();
    zistiTah();
    uloz(cout, prikazy);
    cout << ".\n" << flush;   // bodka a flush = koniec odpovede
   // cerr << "Som skoncil\n";
  }

  return 0;
}

