
Čo je proboj
------------

Proboj je počítačová hra, ktorej hráčmi nie ste vy, ale programy, čo napíšete.

Tentoraz je téma proboja **tower defense**. Každý hráč má mapku, na ktorej môže
stavať veže, a posielať útočníkov na mapky ostatných hráčov. Útočníci pochodujú
do cieľa a veže po nich strieľajú. Ak sú veže slabé a nejaký útočník sa dostane
až do cieľa, ten obranca prehral a útočník získava body.


Zdrojáky
--------

Štandardný hráč čiže klient (v adresári `klienti/template`) sa skladá z jediného
zdrojáku `main.cpp`. Ale môžte ho rozdeliť aj na viacero. Dokonca môžte použiť
aj iný jazyk (aj keď to je trochu problematické, v prípade záujmu sa ma
opýtajte).

V serveri je tiež zopár zdrojákov, čo vás bude zaujímať.

- `common.h` obsahuje základné štruktúry, čo váš klient dostane k dispozícii.
- `update.cpp` a `update.h` obsahujú všetky herné konštanty, a tiež
  implementáciu väčšiny herných pravidiel, takže ak v pravidlách nie je niečo
  jasné, skúste sa tam pozrieť.
- v `main.cpp` sú tiež nejaké pravidlá (ako sa ťahá apod.), ale to je asi menej
  dôležité.

Kľudne si prečítajte aj ostatné zdrojáky, ja sa len poteším, ale pri kódení
vášho klienta vám asi nepomôžu.


Ako kódiť klienta
-----------------

Skopírujte obsah `klienti/template` do iného adresára a niečo v ňom nakóďte.

V koreni proboju spustite `make`, čím všetko skompilujete. (Ak váš klient nie je
vnútri `klienti`, nastavte v jeho `Makefile` správny `SERVERDIR` a spustite
`make` aj v ňom.) Potom spustite `./server/server` (najprv bez parametrov a on
vám povie, aké parametre treba).

Server sa vášho klienta pýta, čo chce robiť. Ak klient neodpovie včas, bude
automaticky zabitý a reštartovaný. Prvýkrát dostane viac času, aby sa mohol
inicializovať.

Keď server spustíte u vás, je to len na skúšku. Na hlavnom počítači to beží na
ostro. Je tam aj webové rozhranie, cez ktoré môžete uploadovať vašich klientov.
Uploadujú sa zdrojáky a tie sa potom skompilujú (konkrétne sa spustí `make
naserveri SERVERDIR=/adresar/kde/je/server`).


Pravidlá hry
------------

Na políčkach mapy je buď **cesta**, po ktorej chodia nepriatelia (vždy
idú niektorou najkratšou cestou), **pozemok**, kde môžete stavať veže, alebo
**voda**, kde sa nedá nič. Plus ešte cieľ, spawn (vchod nepriateľov) atď.

Hra prebieha v kolách. V každom kole ťahajú všetci naraz. Počas svojho ťahu môžu
hráči robiť viacero vecí (príkazov) -- stavať veže, búrať veže, aktivovať veže
alebo posielať útočníkov na ostatných hráčov. Potom sa kopa vecí stane
automaticky: útočníci sa pohnú, veže si zastrieľajú, pribudne drevo atď.

Príkazy sa nemusí podariť vykonať -- napríklad zvolíte zlé políčko, máte málo
dreva, apod. Ale o tom sa dozviete ešte pred tým, ako svoje príkazy pošlete
serveru, a môžte sa podľa toho zariadiť.

Okrem spomínaného dreva (ktoré treba na väčšinu príkazov -- aj na búranie)
existujú aj iné dôležité veličiny. Na hracej ploche sa napríklad nachádzajú
bohaté ložiská ovocnej energie. Každé políčko môže mať inak veľké ložisko (aj
medzi dvoma partiami na rovnakej mape). A už je len to najmenej, túto energiu z
okolia nasať a zúžitkovať. Dôležitou jednotkou energie je jeden náboj, pretože
jeden náboj je také množstvo, s ktorým sa vežiam dobre pracuje. Energiu meriame
v milinábojoch.

Veže a útočníci navyše môžu mať motiváciu čiže level. Čím je veža
motivovanejšia, tým lepšie funguje, tým silnejšie strieľa a tým krajšie sa
usmieva. Väčšina veží sa dá motivovať neobmedzene veľa krát a stále sa ďalej a
ďalej zlepšuje, ale niektoré rozlišujú len dve možnosti - "vôbec nemotivovaná" a
"aspoň trochu motivovaná", a motivovať ich viackrát už nemá ďalšie výhody.


Útočníci
--------

V cieli sa nachádza vaše Ovocie. Musíte ho brániť za každú cenu. O jeho
zničenie sa budú pokúšať **vošky**, **muchy**, **húsenice**, **slimáky** a
**medvede**. Muchy sú síce slabé, ale rýchle, a chodia vo veľkých rojoch.
Slimáky sú pomalé, ale ich ulita ich chráni pred väčšinou útokov. A medvede
chodia v malých skupinách, ale majú oproti ostatným podstatne viac životov.


Veže
----

Veže sa môžu prichádzajúcemu tvorstvu brániť týmito zbraňami: **laser**,
chemický **postrek**, **lupa** na pálenie slnečnými lúčmi, **čary** a
zaklínadlá, **šípy**, **lienky** a **plácačka**. Každá veža má iné vlastnosti,
čo sa týka toho, na koho sa hodí a na koho nie. Podľa typu veže a typu útočníka
(teda proti veži vlastne obrancu) môže strela byť rôzne efektívna, od 0
(žiaden efekt) po 4 (je to *super efektívne*). Konkrétne konštanty nájdete,
podobne ako všetky ostatné, v `update.cpp`.

Lupa môže za cenu jedného náboja aktivovať špeciálny útok, ktorý zasiahne
všetkých útočníkov na území 3x3 okolo vybraného políčka. (To políčko musí byť v
dosahu.) Keď majú lienkové veže dostatok energie, s každým útokom spomaľujú
nepriateľov. Čarovné veže potrebujú energiu už len na to, aby poriadne fungovali
-- ak sa im minie, útočia slabšie.

Okrem útočných veží existujú aj ďalšie:

**Zberači** zbierajú drevo. Ale sú tým drahší, čím viac ich máte. Teda, ostatné
veže vlastne tiež, ale zberači zvlášť. Zberači sa nedajú aktivovať ani
motivovať.

**Nasávače** nasávajú energiu, a to tým rýchlejšie, čím je pod nimi väčšie
ložisko. Ak sú aspoň trochu motivovaní, ešte o stupeň sa zrýchlia. Navyše sa
dokážu aktivovať a poslať tým jeden náboj inej blízkej veži -- to je hlavný
spôsob, ako sa energia medzi vežami dá presúvať. (Dajú sa aktivovať, aj keď
nemajú celý náboj, ale vtedy sa polovica energie pri prenose stratí.)

Keď sa **motivátory** aktivujú, na pár kôl motivujú inú blízku vežu. Veže sa
dajú motivovať aj viackrát. Motivátor nemôže motivovať sám seba. Ak je motivátor
aspoň trochu motivovaný, pri aktivácii nezvýši motiváciu iba na pár kôl, ale
trvalo. Bohužiaľ sa pritom od toľkého úsilia zničí.

**Laboratóriá** existujú v piatich typoch, jedno za každý typ útočníkov. Keď
postavíte laboratórium daného typu, získavate možnosť útočiť na ostatných s
týmto typom. Motivované laboratóriá dokážu šľachtiť lepšie a lepšie odrody
útočníkov a skúmať, ako ich čo najlepšie vylepšiť, takže každé laboratórium,
ktoré je v čase vyslania útoku aspoň trochu motivované, zvyšuje level útočníkov
o jedna. To sa odrazí na životoch a počte útočníkov.
