#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <unistd.h>
#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;

#include "common.h"
#include "marshal.h"
#include "update.h"
#define ja stav.hraci[0]
#define For(Q,W) for(int Q=0;Q<W;Q++)

#define UTOK 0;
#define OBRANA 1;
#define ZBERAJ 2;


Mapa mapa;
Stav stav;   // vzdy som hrac cislo 0
vector<Prikaz> prikazy;
int naKoho;
int kolo;
int flag;
int zmena_dreva,old_dreva;

int delta_g;
int akoBudemUtocit;
double zdroje_attack, zdroje_def, zdroje_gather;
int banka_attack, banka_def, banka_gather;

/*new*/vector<pair<int,int> > kamStavatVeze, kamStavatTazbu;
queue<pair<int,int> > haldicka;
/*mapa na hodnoty ciest*/ vector<vector<double> > hodnota_cesty;
			  vector<vector<int> > vzdialenost_bodu;
int dx[4] = {-1,0,1,0};
int dy[4] = {0,1,0,-1};
  
int dx2[8] ={-1,0,1,-1,1,-1,0,1};
int dy2[8] ={-1,-1,-1,0,0,1,1,1};


void sup(double a,double b, double c){
    zdroje_attack=a;
    zdroje_def=b;
    zdroje_gather=c;
}

bool special(){
  int ok_hrac=0;
  For(i,mapa.pocetHracov) if(stav.hraci[i].umrel==0) ok_hrac++;
  
  if(ok_hrac<2){
      sup(0.0,0.8,0.2);
    return true;
  }
  else   return false;
  
}

void divide(){
  if(!special()){
  if(kolo<15)		sup(0.0,0.0,1.0);
  else if(kolo<300)	sup(0.0,1.0,0.0);
  else if(kolo<400)	sup(0.0,0.6,0.4);
  else if(kolo<700)	sup(0.3,0.6,0.1);
  else 			sup(0.8,0.1,0.1);
  }
}

// pomocna funkcia. volajte zo zistiTah(), napr.:
// if (!vykonaj(Prikaz::stavaj(10, 10, VEZA_LASER))) { /* zeby malo dreva? */ }
bool vykonaj(const Prikaz& p) {
  delta_g=ja.drevo;
  bool uspech = vykonajPrikaz(mapa, stav, 0, p);
  if (uspech){ prikazy.push_back(p); delta_g-=ja.drevo}   // potom to posleme serveru
  
  if(flag==UTOK){
      banka_attack-=delta_g;
  }
  else if(flag==OBRANA){
      banka_def-=delta_g;
  }
  else {
      banka_gather-=delta_g;
  }

  return uspech;
}


void trtko(int desom_x, int desom_y,double pocetnost){
  hodnota_cesty[desom_y][desom_x]+=pocetnost;
 
  double posible=0;
  
  For(i,4){
      if((mapa.zisti(desom_x+dx[i],desom_y+dy[i])>1)&&(vzdialenost_bodu[desom_y+dy[i]][desom_x+dx[i]]<vzdialenost_bodu[desom_y][desom_x])) posible++;  
  }
  
  For(i,4){
      if(mapa.zisti(desom_x+dx[i],desom_y+dy[i])>1&&vzdialenost_bodu [desom_y+dy[i]] [desom_x+dx[i]]<vzdialenost_bodu[desom_y][desom_x]){
	trtko(desom_x+dx[i],desom_y+dy[i],pocetnost/posible);  
      }
  }
  
  
  
}

void initHodnotaCesty(){
  int domcek_x,domcek_y;
    For(i,mapa.h) For(j,mapa.w) if(mapa.pole[i][j]==MAPA_CIEL) { domcek_x=j ;domcek_y=i;}  // najdeme domcek
    
    //For(i,mapa.h) For(j,mapa.w){ vzdialenost_bodu[i][j]=999999999; hodnota_cesty[i][j]=0}// najdeme domcek
    hodnota_cesty.resize(mapa.h,vector<double>(mapa.w,0));
    vzdialenost_bodu.resize(mapa.h,vector<int>(mapa.w,999999999));
    
    
    haldicka.push(make_pair(domcek_x,domcek_y));
    vzdialenost_bodu[domcek_y][domcek_x]=1;
    
    while(!haldicka.empty()){
	 pair<int,int> desom=haldicka.front();
	 haldicka.pop();
	 
	 For(i,4){
	    int nove_x=desom.first+dx[i],nove_y=desom.second+dy[i];
	    
	    if((mapa.zisti(nove_x,nove_y)>1)&&(vzdialenost_bodu[nove_y][nove_x]>vzdialenost_bodu[desom.second][desom.first]+1)){
		vzdialenost_bodu[nove_y][nove_x]=vzdialenost_bodu[desom.second][desom.first]+1;
		
		haldicka.push(make_pair(nove_x,nove_y));
	    }
	   
	}
	 
    }
    
    For(i,mapa.h) For(j,mapa.w) if(mapa.pole[i][j]==MAPA_SPAWN) trtko(j,i,1);
    
}

void initKamStavat(){	//Mario
    vector<vector<double> >hodnota_pozemku(mapa.h,vector<double>(mapa.w,0));
    For(i,mapa.h) For(j,mapa.w) if(mapa.zisti(j,i)>1){
      For(k,8)if(mapa.zisti(j+dx2[k],i+dy2[k])==MAPA_POZEMOK) 
	hodnota_pozemku[i+dy2[k]][j+dx2[k]] += hodnota_cesty[i][j]; 
    }
    vector<pair<double,pair<int,int> > > zor;
    For(i,mapa.h) For(j,mapa.w) 
      if(mapa.zisti(j,i)==MAPA_POZEMOK)
	zor.push_back(make_pair(hodnota_pozemku[i][j],make_pair(j,i)));
    sort(zor.begin(), zor.end());
    For(i,zor.size()){
      kamStavatTazbu.push_back(zor[zor.size()-i-1].second);
      kamStavatVeze.push_back(zor[i].second);
    }
    For(i,mapa.h){ For(j,mapa.w){
      cerr << hodnota_pozemku[i][j] << " ";
    }
      cerr << endl;
    }
}

// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
  old_dreva=0;
  srand(time(NULL) * getpid());
  akoBudemUtocit = rand() % UTOCNIK_POCET_TYPOV;
  
  initHodnotaCesty();
  initKamStavat();
  For(i,mapa.h){ For(j,mapa.w){
      cerr << vzdialenost_bodu[i][j] << " ";
    }
      cerr << endl;
    }
    For(i,mapa.h){ For(j,mapa.w){
      cerr << hodnota_cesty[i][j] << " ";
    }
      cerr << endl;
    }
}

int pocetVezi(int typ) {
  int result = 0;
  FOREACH(it, stav.hraci[0].veze) if (it->typ == typ) result++;
  return result;
}

int zistiCenuVeze(int kolko, int typ) {
  int pocet = kolko;
  FOREACH(it, ja.veze) if (it->typ == typ) pocet++;
  return kVezaCena0[typ] + pocet * kVezaCena1[typ] + pocet * pocet * kVezaCena2[typ];
}

void attack(){
  int ako_utocim= rand()%UTOCNIK_POCET_TYPOV;
  int posible=ja.drevo*zdroje_attack;
  for(int i=1; i<mapa.pocetHracov;i++)
  if(stav.hraci[i].umrel)continue;
  else {
      naKoho=i;
    break;
  }
    
  while (pocetVezi(VEZA_LAB_PRVY+ako_utocim) < 1&& zistiCenuVeze(0,VEZA_LAB_PRVY+ako_utocim)<banka_attack) {
    pair<int,int> kamStavat;
    if(kamStavatTazbu.size() > 0){
      kamStavat = kamStavatTazbu.back(); 
      kamStavatTazbu.pop_back();}
    else
      kamStavat = make_pair(0,0);
    if (!vykonaj(Prikaz::buduj(kamStavat.first, kamStavat.second, VEZA_LAB_PRVY+ako_utocim))) break;
  }
  if(kolo%200){
  while (posible) {
    if (!vykonaj(Prikaz::utoc(ako_utocim, naKoho))) break;
    posible-=kVezaCena0[ako_utocim];
  }
  }
}

void def(){
  int stavane=0;
  int counter=0;
  int aky_def=rand()%VEZA_POCET_BOJOVYCH;
  
  while (banka_def>zistiCenuVeze(stavane,aky_def)) {
    pair<int,int> kamStavat;
    if(kamStavatVeze.size() > 0){
      kamStavat = kamStavatVeze.back(); 
      kamStavatVeze.pop_back();}
    else
      kamStavat = make_pair(0,0);
    if(vykonaj(Prikaz::buduj(kamStavat.first,kamStavat.second, aky_def)))
    stavane++;
    
    counter++;
    if(counter>30) break;
  } 
}

void gather(){
  int stavane=0;
  int counter=0;
  while (pocetVezi(VEZA_ZBERAC) < (mapa.w*mapa.h)/1 && banka_gather>zistiCenuVeze(stavane,VEZA_ZBERAC)) {
    pair<int,int> kamStavat;
    if(kamStavatTazbu.size()>0){
      kamStavat = kamStavatTazbu.back(); 
      kamStavatTazbu.pop_back();}
    else kamStavat = make_pair(0,0);
    vykonaj(Prikaz::buduj(kamStavat.first, kamStavat.second, VEZA_ZBERAC));
    counter++;
    stavane++;
    if(counter>10) break;
  }
    
}

// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat
void zistiTah() {
  zdroje_attack=0, zdroje_def=0, zdroje_gather=0;
  zmena_dreva=ja.drevo-old_dreva;
  
  kolo++;
  divide();
  
  banka_attack+=zmena_dreva*zdroje_attack;
  banka_def+=zmena_dreva*zdroje_def;
  banka_gather+=zmena_dreva*zdroje_gather;
  
  if(kolo%4==1){
    flag=UTOK;
    attack();
    flag=OBRANA;
    def();
    flag=ZBERAJ;
    gather();
  }
  /*
  int mojLab = VEZA_LAB_PRVY + akoBudemUtocit;
  while (pocetVezi(VEZA_ZBERAC) < 3) {
    if (!vykonaj(Prikaz::buduj(rand() % mapa.w, rand() % mapa.h, VEZA_ZBERAC))) break;
  }
  while (pocetVezi(mojLab) < 1) {
    if (!vykonaj(Prikaz::buduj(rand() % mapa.w, rand() % mapa.h, mojLab))) break;
  }
  while (true) {
    int naKoho = 1 + rand() % (mapa.pocetHracov-1);
    if (!vykonaj(Prikaz::utoc(akoBudemUtocit, naKoho))) break;
  }
  // hmm este nejaku obranu by to chcelo...
  */
  
  old_dreva=ja.drevo;
}


int main() {
  // v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

  nacitaj(cin, mapa);
  inicializuj();
  kolo=0;
  while (cin.good()) {
    nacitaj(cin, stav);
    prikazy.clear();
    zistiTah();
    uloz(cout, prikazy);
    cerr << kamStavatTazbu.size() << endl;
    cerr << kamStavatVeze.size() << endl;
    cout << ".\n" << flush;   // bodka a flush = koniec odpovede
  }

  return 0;
}

