#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <unistd.h>
#include <iostream>
#include <vector>
using namespace std;

#include "common.h"
#include "marshal.h"
#include "update.h"


Mapa mapa;
Stav stav;   // vzdy som hrac cislo 0
vector<Prikaz> prikazy;

int akoBudemUtocit;


// pomocna funkcia. volajte zo zistiTah(), napr.:
// if (!vykonaj(Prikaz::stavaj(10, 10, VEZA_LASER))) { /* zeby malo dreva? */ }
bool vykonaj(const Prikaz& p) {
  bool uspech = vykonajPrikaz(mapa, stav, 0, p);
  if (uspech) prikazy.push_back(p);   // potom to posleme serveru
  return uspech;
}

vector <int> posx;
vector <int> posy;

void inicPos (){
	for (int i=0; i<mapa.w; i++) {
		for (int j=0; j<mapa.h; j++){
			int x = i, y = j;
			if(mapa.priechodne(x, y)) continue;
			if(mapa.priechodne(x+1, y) || mapa.priechodne(x, y+1) || mapa.priechodne(x-1, y) || mapa.priechodne(x, y-1)){
				posx.push_back(x);
				posy.push_back(y);
			}
		}
	}
	cerr << "OK" << endl;
}



// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
  srand(time(NULL) * getpid());
  akoBudemUtocit = rand() % UTOCNIK_POCET_TYPOV;
  
  inicPos ();
}


int pocetVezi(int typ) {
  int result = 0;
  FOREACH(it, stav.hraci[0].veze) if (it->typ == typ) result++;
  return result;
}



int count = 0;

// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat
void zistiTah() {
	
	
  int mojLab = VEZA_LAB_PRVY + akoBudemUtocit;
  while (pocetVezi(VEZA_ZBERAC) < 3) {
    if (!vykonaj(Prikaz::buduj(rand() % mapa.w, rand() % mapa.h, VEZA_ZBERAC))) break;
  }
  while (pocetVezi(mojLab) < 1) {
    if (!vykonaj(Prikaz::buduj(rand() % mapa.w, rand() % mapa.h, mojLab))) break;
  }
  for (int i=0; i<1000; i++) {
	  int r = rand() % posx.size();
	  if(vykonaj(Prikaz::buduj(posx[r], posy[r], rand() % 7))) count ++;
  }
  
  if (count >= posx.size()) {
    for (int i=0; i<1000; i++)  {
	  vykonaj(Prikaz::buduj(rand() % mapa.w, rand() % mapa.h, rand() % 5 + 10));
    }
  }
  
  while (true) {
	bool konc = false;
    for (int i= VEZA_LAB_PRVY; i< VEZA_POCET_TYPOV; i++){
		int naKoho = 1 + rand() % (mapa.pocetHracov-1);
		if (!vykonaj(Prikaz::utoc(i, naKoho))) konc = true;
	}
	if(konc) break;
  }
  // hmm este nejaku obranu by to chcelo...
}


int main() {
  // v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

  nacitaj(cin, mapa);
  inicializuj();

  while (cin.good()) {
    nacitaj(cin, stav);
    prikazy.clear();
    zistiTah();
    uloz(cout, prikazy);
    cout << ".\n" << flush;   // bodka a flush = koniec odpovede
  }

  return 0;
}

