#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <unistd.h>
#include <iostream>
#include <vector>
using namespace std;

#include "common.h"
#include "marshal.h"
#include "update.h"


Mapa mapa;
Stav stav;	 // vzdy som hrac cislo 0
vector<Prikaz> prikazy;

int akoBudemUtocit;


// pomocna funkcia. volajte zo zistiTah(), napr.:
// if (!vykonaj(Prikaz::stavaj(10, 10, VEZA_LASER))) { /* zeby malo dreva? */ }
bool vykonaj(const Prikaz& p) {
	bool uspech = vykonajPrikaz(mapa, stav, 0, p);
	if (uspech) prikazy.push_back(p);	 // potom to posleme serveru
	return uspech;
}

vector <int> posx;
vector <int> posy;

bool jePriCeste (int x, int y) {
	return mapa.priechodne(x+1, y) || mapa.priechodne(x, y+1) || mapa.priechodne(x-1, y) || mapa.priechodne(x, y-1);	
}


void inicPos (){
	for (int i=0; i<mapa.w; i++) {
		for (int j=0; j<mapa.h; j++){
			int x = i, y = j;
			if(mapa.priechodne(x, y)) continue;
			if(jePriCeste(x, y)){
				posx.push_back(x);
				posy.push_back(y);
			}
		}
	}
	cerr << "OK" << endl;
}



// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
	srand(time(NULL) * getpid());
	akoBudemUtocit = rand() % UTOCNIK_POCET_TYPOV;
	
	inicPos ();
}


int pocetVezi(int typ) {
	int result = 0;
	FOREACH(it, stav.hraci[0].veze) if (it->typ == typ) result++;
	return result;
}

int countAtk (){
	int res = 0;
	for (int i=0; i<VEZA_POCET_BOJOVYCH; i++){
		res+= pocetVezi(i);
	}
	return res;
}

// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat
void zistiTah() {
	
	
	int mojLab = VEZA_LAB_MEDVED ;
	
	while (pocetVezi(mojLab) < 1) {
		int x, y;
		do {
			x = rand() % mapa.w;
			y = rand() % mapa.h;
		}
		while(jePriCeste(x,y));
			
		if (!vykonaj(Prikaz::buduj(x, y, mojLab))) break;
	}
	
	for (int i=0; i<1000; i++)
		while ((pocetVezi(VEZA_ZBERAC) < 3)||(double)countAtk() / pocetVezi(VEZA_ZBERAC)+1 > 2) {
			int x, y;
			do {
				x = rand() % mapa.w;
				y = rand() % mapa.h;
			}
			while(jePriCeste(x,y));
			
			if (!vykonaj(Prikaz::buduj(x, y, VEZA_ZBERAC))) break;
		}
	
	for (int i=0; i<1000; i++) {
		int r = rand() % posx.size();
		vykonaj(Prikaz::buduj(posx[r], posy[r], rand() % 7));
	}
	
	for (int i=0; i<1000; i++){
		int naKoho = 1 + rand() % (mapa.pocetHracov-1);
		if (vykonaj(Prikaz::utoc(mojLab, naKoho))) break;
	}
	// hmm este nejaku obranu by to chcelo...
}


int main() {
	// v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

	nacitaj(cin, mapa);
	inicializuj();

	while (cin.good()) {
		nacitaj(cin, stav);
		prikazy.clear();
		zistiTah();
		uloz(cout, prikazy);
		cout << ".\n" << flush;	 // bodka a flush = koniec odpovede
	}

	return 0;
}

