#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <unistd.h>
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#include "common.h"
#include "marshal.h"
#include "update.h"


Mapa mapa;
Stav stav;	 // vzdy som hrac cislo 0
vector<Prikaz> prikazy;

int akoBudemUtocit;


// pomocna funkcia. volajte zo zistiTah(), napr.:
// if (!vykonaj(Prikaz::stavaj(10, 10, VEZA_LASER))) { /* zeby malo dreva? */ }
bool vykonaj(const Prikaz& p) {
	bool uspech = vykonajPrikaz(mapa, stav, 0, p);
	if (uspech) prikazy.push_back(p);	 // potom to posleme serveru
	return uspech;
}

vector <int> posx;
vector <int> posy;

struct policko {
	int x;
	int y;
	int h;
	
	policko (int a, int b, int c) {
		x = a;
		y = b;
		h = c;
	}
	
	bool operator < (const policko &b) const {
		return h > b.h;
	}
};

vector <policko> naj;

bool jePriCeste (int x, int y) {
	return mapa.priechodne(x+1, y) || mapa.priechodne(x, y+1) || mapa.priechodne(x-1, y) || mapa.priechodne(x, y-1);	
}


void inicPos (){
	for (int i=0; i<mapa.w; i++) {
		for (int j=0; j<mapa.h; j++){
			int x = i, y = j;
			naj.push_back(policko(x, y, mapa.loziska[y][x]));
			
			if(mapa.priechodne(x, y)) continue;
			
			if(jePriCeste(x, y)){
				posx.push_back(x);
				posy.push_back(y);
			}
			
		}
	}
	
	sort (naj.begin(), naj.end());
	for (int i=0; i<naj.size(); i++) {
		cerr << naj[i].h << " ";
	}
	cerr << "OK" << endl;
}



// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
	srand(time(NULL) * getpid());
	akoBudemUtocit = rand() % UTOCNIK_POCET_TYPOV;
	
	inicPos ();
}


int pocetVezi(int typ) {
	int result = 0;
	FOREACH(it, stav.hraci[0].veze) if (it->typ == typ) result++;
	return result;
}

int countAtk (){
	int res = 0;
	for (int i=0; i<VEZA_POCET_BOJOVYCH; i++){
		res+= pocetVezi(i);
	}
	return res;
}

int getVeza (int x, int y){
	for (int i=0; i<stav.hraci[0].veze.size(); i++){
		if (stav.hraci[0].veze[i].x != x) continue;
		if (stav.hraci[0].veze[i].y != y) continue;	
		return stav.hraci[0].veze[i].typ;
	}
	return -1;
}

// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat
void zistiTah() {
	
	
	int mojLab = VEZA_LAB_MEDVED, mojLab2 = VEZA_LAB_MUCHA;
	
	
	for (int i=0; i<1000; i++) {
		if (countAtk() > 5) break;
		int r = rand() % posx.size();
		int type = rand() % 8;
		if (type == 7) type = VEZA_PLACACKA; 
		vykonaj(Prikaz::buduj(posx[r], posy[r], type));
	}
	
	if (countAtk() < 4) return;

	while (pocetVezi(mojLab) < 1) {
		int x, y;
		do {
			x = rand() % mapa.w;
			y = rand() % mapa.h;
		}
		while(jePriCeste(x,y));
			
		if (!vykonaj(Prikaz::buduj(x, y, mojLab))) break;
	}
	
	
	/*for (int i=0; i<4; i++) {
		int m = i;
		if (pocetVezi(VEZA_NASAVAC) >=4) break;
		
		if (getVeza(naj[m].x, naj[m].y) != VEZA_NASAVAC) vykonaj(Prikaz::buraj(naj[m].x, naj[m].y));
		vykonaj(Prikaz::buduj(naj[m].x, naj[m].y, VEZA_NASAVAC));
		cerr << naj[m].h<<" ";
	}*/
	cerr <<endl;
	
	while (pocetVezi(mojLab2) < 1) {
		int x, y;
		do {
			x = rand() % mapa.w;
			y = rand() % mapa.h;
		}
		while(jePriCeste(x,y));
			
		if (!vykonaj(Prikaz::buduj(x, y, mojLab2))) break;
	}
	
	for (int i=0; i<1000; i++)
		while ((pocetVezi(VEZA_ZBERAC) < 3)||(double)countAtk() / pocetVezi(VEZA_ZBERAC)+1 > 2) {
			int x, y;
			do {
				x = rand() % mapa.w;
				y = rand() % mapa.h;
			}
			while(jePriCeste(x,y));
			
			if (!vykonaj(Prikaz::buduj(x, y, VEZA_ZBERAC))) break;
		}
	
	for (int i=0; i<1000; i++) {
		int r = rand() % posx.size();
		int type = rand() % 8;
		if (type == 7) type = VEZA_PLACACKA; 
		vykonaj(Prikaz::buduj(posx[r], posy[r], type));
	}
	
	for (int i=0; i<1000; i++){
		int naKoho = 1 + rand() % (mapa.pocetHracov-1);
		if (rand() % 2 == 1 ) vykonaj(Prikaz::utoc(mojLab-VEZA_LAB_PRVY, naKoho));
		else vykonaj(Prikaz::utoc(mojLab2-VEZA_LAB_PRVY, naKoho));
	}
}


int main() {
	// v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

	nacitaj(cin, mapa);
	inicializuj();

	while (cin.good()) {
		nacitaj(cin, stav);
		prikazy.clear();
		zistiTah();
		uloz(cout, prikazy);
		cout << ".\n" << flush;	 // bodka a flush = koniec odpovede
	}

	return 0;
}

