// klient s rucnym ovladanim
// nezabudnite pred spustenim servera dat: export NO_TIMEOUTS=true

// ovladanie:
// buduj: qwertyu asd zxcvb
// buraj: Delete
// aktivuj: Space + pohyb + Space
// utoc: 1-9 (cislo urcuje hraca, kurzor selectuje lab)
//   (TODO: nejako ukazovat aj mapovanie, teraz nevies na koho utocis)
// undo: Escape
// koniec tahu: Tab

#include <cstdio>
#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <sstream>
#include <unistd.h>
using namespace std;

#include <cstring>
#include <cerrno>

#include "SDL.h"
#include "SDL_ttf.h"

#include "common.h"
#include "marshal.h"
#include "update.h"


Mapa mapa;
Stav stav;   // vzdy som hrac cislo 0
vector<Prikaz> prikazy;


SDL_Surface *screen;
TTF_Font *font;
int curX, curY;
int activateX = -1, activateY = -1;
string statusString;
map<int,int> buildKlavesy;
const char* utocnici[] = { "voska", "mucha", "husenica", "slimak", "medved" };
const char* veze[] = {
  "laser", "postrek", "lupa", "cary", "sipy", "lienky", "placacka",
  "zberac", "nasavac", "motivator",
  "lab-voska", "lab-mucha", "lab-husenica", "lab-slimak", "lab-medved"
};
const int farbyVezi[] = {
  0x00FF00, 0x80FF00, 0xFFFF00, 0xFF0080, 0xFF8000, 0xFF0000, 0x808000,
  0x0000FF, 0x000080, 0x00FFFF,
  0xaf48ff, 0xaf48ff, 0xaf48ff, 0xaf48ff, 0xaf48ff
};
const int farbyUtocnikov[] = { 0x00FF00, 0x000000, 0x008000, 0xE0CB77, 0x884422 };

#define ZOOM 32


// pomocna funkcia. volajte zo zistiTah(), napr.:
// if (!vykonaj(Prikaz::stavaj(10, 10, VEZA_LASER))) { /* zeby malo dreva? */ }
bool vykonaj(const Prikaz& p) {
  bool uspech = vykonajPrikaz(mapa, stav, 0, p);
  if (uspech) prikazy.push_back(p);   // potom to posleme serveru
  return uspech;
}


// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
  buildKlavesy[SDLK_q] = VEZA_LASER;
  buildKlavesy[SDLK_w] = VEZA_POSTREK;
  buildKlavesy[SDLK_e] = VEZA_LUPA;
  buildKlavesy[SDLK_r] = VEZA_CARY;
  buildKlavesy[SDLK_t] = VEZA_SIPY;
  buildKlavesy[SDLK_y] = VEZA_LIENKY;
  buildKlavesy[SDLK_u] = VEZA_PLACACKA;

  buildKlavesy[SDLK_a] = VEZA_ZBERAC;
  buildKlavesy[SDLK_s] = VEZA_NASAVAC;
  buildKlavesy[SDLK_d] = VEZA_MOTIVATOR;

  buildKlavesy[SDLK_z] = VEZA_LAB_VOSKA;
  buildKlavesy[SDLK_x] = VEZA_LAB_MUCHA;
  buildKlavesy[SDLK_c] = VEZA_LAB_HUSENICA;
  buildKlavesy[SDLK_v] = VEZA_LAB_SLIMAK;
  buildKlavesy[SDLK_b] = VEZA_LAB_MEDVED;

  SDL_Init(SDL_INIT_VIDEO | SDL_INIT_NOPARACHUTE);
  screen = SDL_SetVideoMode(mapa.w*ZOOM, mapa.h*ZOOM, 32, SDL_DOUBLEBUF);
  SDL_EnableKeyRepeat(SDL_DEFAULT_REPEAT_DELAY, SDL_DEFAULT_REPEAT_INTERVAL);
  TTF_Init();

  FILE *p = popen("fc-match -f %{file} monospace", "r");
  char fontfile[1024];
  int len = fread(fontfile, 1, 1023, p);
  fontfile[len] = 0;
  pclose(p);
  font = TTF_OpenFont(fontfile, 32);
  if (!font) {
    fprintf(stderr, "error opening font '%s'\n", fontfile);
    exit(1);
  }
}


void fillrect(int x, int y, int w, int h, int c) {
  c = SDL_MapRGB(screen->format, (c>>16)&0xFF, (c>>8)&0xFF, c&0xFF);
  SDL_Rect r = { (Sint16)x, (Sint16)y, (Uint16)w, (Uint16)h };
  SDL_FillRect(screen, &r, c);
}


void rect(int x, int y, int c) {
  int d = 2;
  fillrect(x*ZOOM, y*ZOOM, ZOOM, d, c);
  fillrect(x*ZOOM, y*ZOOM, d, ZOOM, c);
  fillrect(x*ZOOM, y*ZOOM+ZOOM-d, ZOOM, d, c);
  fillrect(x*ZOOM+ZOOM-d, y*ZOOM, d, ZOOM, c);
}


void kresli() {
  // nastavime title
  stringstream buf;
  buf << "PID=" << getpid() << " cas=" << stav.cas;
  buf << " drevo=" << stav.hraci[0].drevo;
  if (stav.hraci[0].body) buf << " body=" << stav.hraci[0].body;
  if (mapa.loziska[curY][curX]) buf << " lozisko=" << mapa.loziska[curY][curX];
  FOREACH(it, stav.hraci[0].veze) {
    if (it->x == curX && it->y == curY) {
      buf << " " << veze[it->typ] << " e=" << it->energia
          << " level=" << it->baseLevel << "+" << it->levelBonusy.size();
    }
  }
  FOREACH(it, stav.hraci[0].utocnici) {
    if (it->x == curX && it->y == curY) {
      buf << " {" << utocnici[it->typ] << " " << it->hp << " from=" << it->ktorehoHraca
          << " pT" << it->pohybovyTimer;
      if (it->kolkoSpomaleny) buf << " slow" << it->kolkoSpomaleny;
      buf << "}";
    }
  }
  buf << " [" << prikazy.size() << "] " << statusString;
  SDL_WM_SetCaption(buf.str().c_str(), buf.str().c_str());

  // vykreslime mapu
  for (int y = 0; y < mapa.h; y++) for (int x = 0; x < mapa.w; x++) {
    int m = mapa.zisti(x, y);
    int c =
      m == MAPA_VODA ? 0x000080 :
      m == MAPA_POZEMOK ? 0x000000 :
      m == MAPA_CESTA ? 0xFFFFFF :
      m == MAPA_CIEL ? 0x008000 :
      m == MAPA_SPAWN ? 0x800000 : 0x888888;
    fillrect(x*ZOOM, y*ZOOM, ZOOM, ZOOM, c);
  }

  // vykreslime veze
  FOREACH(it, stav.hraci[0].veze) {
    fillrect(it->x*ZOOM + 4, it->y*ZOOM + 4, ZOOM - 8, ZOOM - 8, farbyVezi[it->typ]);
  }

  // vykreslime utocnikov
  vector<Utocnik>& us = stav.hraci[0].utocnici;
  for (unsigned i = 0; i < us.size(); i++) {
    fillrect(
        us[i].x*ZOOM + (i%3)*(ZOOM/3) + 2,
        us[i].y*ZOOM + ((i/3)%3)*(ZOOM/3) + 2,
        ZOOM/3-1, ZOOM/3-1, farbyUtocnikov[us[i].typ]);
  }

  // vykreslime kurzor
  rect(curX, curY, 0xFF0000);
  if (activateX != -1) rect(activateX, activateY, 0xFFFF00);
}


void skus(Prikaz co) {
  if (activateX != -1) activateX = activateY = -1;
  statusString = vykonaj(co) ? string("OK") : string("WA");
}


// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat
void zistiTah() {
  Stav orig = stav;
  bool run = true;
  while (run) {
    kresli();
    SDL_Flip(screen);
    SDL_Delay(50);
    SDL_Event event;
    while (SDL_PollEvent(&event)) {
      if (event.type == SDL_QUIT) {
        SDL_Quit();
        exit(1);
      }
      if (event.type == SDL_KEYDOWN) {
        int sym = event.key.keysym.sym;
        statusString = "";
        if (sym == SDLK_LEFT && curX) curX--;
        if (sym == SDLK_RIGHT && curX < mapa.w-1) curX++;
        if (sym == SDLK_UP && curY) curY--;
        if (sym == SDLK_DOWN && curY < mapa.h-1) curY++;
        if (sym == SDLK_DELETE) skus(Prikaz::buraj(curX, curY));
        if (sym == SDLK_TAB) activateX = activateY = -1, run = false;
        if (sym == SDLK_ESCAPE) {
          stav = orig;
          prikazy.clear();
        }
        if (sym == SDLK_SPACE) {
          if (activateX == -1) activateX = curX, activateY = curY;
          else skus(Prikaz::aktivuj(activateX, activateY, curX, curY));
        }
        if (buildKlavesy.count(sym)) skus(Prikaz::buduj(curX, curY, buildKlavesy[sym]));
        else if (sym >= SDLK_1 && sym <= SDLK_9) {
          int typ = -1;
          vector<Veza>& vs = stav.hraci[0].veze;
          for (unsigned i = 0; i < vs.size(); i++) {
            if (vs[i].x == curX && vs[i].y == curY && vs[i].typ >= VEZA_LAB_PRVY) {
              typ = vs[i].typ - VEZA_LAB_PRVY;
            }
          }
          if (typ != -1) skus(Prikaz::utoc(typ, sym - SDLK_1 + 1));
        }
      }
    }
  }
  SDL_FillRect(screen, NULL, SDL_MapRGB(screen->format, 0, 0, 0));
  SDL_Flip(screen);
}


int main() {
  // v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

  nacitaj(cin, mapa);
  inicializuj();

  while (cin.good()) {
    nacitaj(cin, stav);
    prikazy.clear();
    zistiTah();
    uloz(cout, prikazy);
    cout << ".\n" << flush;   // bodka a flush = koniec odpovede
  }

  return 0;
}

