#include <cstdio>
#include <cstdlib>
#include <string>
#include <unistd.h>
#include <iostream>
#include <vector>
using namespace std;

#include "common.h"
#include "marshal.h"
#include "update.h"


int mojeCislo;
Mapa mapa;
Stav stav;   // vzdy som hrac cislo 0
vector<Prikaz> prikazy;
int cakanie1, cakanie2, cakanie;
int utokTyp, utokLevel, utokPocet;
int obranaTyp, obranaLevel, obranaPocet;
vector<pair<int,int> > obranaMiesta;


// pomocna funkcia. volajte zo zistiTah(), napr.:
// if (!vykonaj(Prikaz::stavaj(10, 10, VEZA_LASER))) { /* zeby malo dreva? */ }
bool vykonaj(const Prikaz& p) {
  bool uspech = vykonajPrikaz(mapa, stav, 0, p);
  if (uspech) prikazy.push_back(p);   // potom to posleme serveru
  return uspech;
}


pair<int,int> zistiDrevo(int chcemdrevo) {
  // result je (kolko to bude trvat, kolko dedincanov postavit)
  pair<int,int> best(chcemdrevo, -1);
  for (int chcemded = 0; chcemded <= chcemdrevo/kPrisunDreva; chcemded++) {
//fprintf(stderr, "test chcemded=%d\n", chcemded);
    int terazcas = 0, terazded = 0, terazdreva = kUvodneDrevo;
    while (terazdreva < chcemdrevo) {
      // nakup dedincanov kolko mozes
      while (terazded < chcemded) {
        int cena = kVezaCena0[VEZA_ZBERAC] +
            terazded * kVezaCena1[VEZA_ZBERAC] +
            terazded * terazded * kVezaCena2[VEZA_ZBERAC];
        if (terazdreva < cena) break;
        terazdreva -= cena;
        terazded++;
      }
      terazdreva += terazded * kPrisunDreva + kPrisunDrevaZaklad;
//fprintf(stderr, "po kole %d: terazded=%d terazdreva=%d\n", terazcas, terazded, terazdreva);
      terazcas++;
    }
//fprintf(stderr, "vyslo terazded=%d terazcas=%d\n", terazded, terazcas);
    if (terazcas < best.first) best = make_pair(terazcas, terazded);
  }
  return best;
}


pair<int,int> zistiHlupeDrevo(int chcemdrevo) {
  int terazcas = 0, terazded = 0, terazdreva = kUvodneDrevo;
  while (terazdreva < chcemdrevo) {
    if (terazcas > terazded * terazded * 40 || terazded <= 2) {
      int cena = kVezaCena0[VEZA_ZBERAC] +
          terazded * kVezaCena1[VEZA_ZBERAC] +
          terazded * terazded * kVezaCena2[VEZA_ZBERAC];
      if (terazdreva >= cena) terazdreva -= cena, terazded++;
    }
    terazdreva += terazded * kPrisunDreva + kPrisunDrevaZaklad;
    terazcas++;
  }
  return make_pair(terazcas, terazded);
}


// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
  mojeCislo = getpid() - getppid();
  FILE *f = fopen("testdata", "r");
  if (f == NULL) {
    fprintf(stderr, "nemam testdata");
    exit(1);
  }
  fscanf(f, "%d%d%d%d%d%d%d%d",
      &cakanie1, &cakanie2,
      &utokTyp, &utokLevel, &utokPocet,
      &obranaTyp, &obranaLevel, &obranaPocet);
  obranaMiesta.resize(obranaPocet);
  for (int i = 0; i < obranaPocet; i++) {
    fscanf(f, "%d%d", &obranaMiesta[i].first, &obranaMiesta[i].second);
  }
  fclose(f);
  cakanie = mojeCislo == 1 ? cakanie1 : cakanie2;
  if (mojeCislo == 1) {
    ;;;
  }
}


// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat
void zistiTah() {
  if (stav.cas < cakanie) {
    // TODO stavat zberacov a nasavacov
    return;
  }
  // ...
}


int main(int argc, char *argv[]) {
  // v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

  if (argc == 2 && string(argv[1]) == "-z") {
    int chcem;
    scanf("%d", &chcem);
    pair<int,int> result = zistiDrevo(chcem);
    printf("%d %d\n", result.first, result.second);
    return 0;
  }
  if (argc == 2 && string(argv[1]) == "-zh") {
    int chcem;
    scanf("%d", &chcem);
    pair<int,int> result = zistiHlupeDrevo(chcem);
    printf("%d %d\n", result.first, result.second);
    return 0;
  }

  nacitaj(cin, mapa);
  inicializuj();

  while (cin.good()) {
    nacitaj(cin, stav);
    prikazy.clear();
    zistiTah();
    uloz(cout, prikazy);
    cout << ".\n" << flush;   // bodka a flush = koniec odpovede
  }

  return 0;
}

