#include <cstdio>
#include <unistd.h>
#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <queue>
#include <algorithm>
using namespace std;

#include "common.h"
#include "marshal.h"
#include "update.h"


const int kTerazded2 = 40;
const int kRezervaDreva = 250;


#define JA (stav.hraci[0])



#define ERASE(v,x) (swap((x), *((v).end() - 1)), (v).pop_back())

static int DX[] = { 0, 1, 0, -1 };
static int DY[] = { -1, 0, 1, 0 };

Mapa mapa;
Stav stav;   // vzdy som hrac cislo 0
vector<Prikaz> prikazy;
Mapa mapaJedenHrac;

// trvale veci
vector<int> dist;
vector<double> mapaprob;
vector<pair<double,pair<int,int> > > dobrePozemky;
vector<pair<int,pair<int,int> > > polickaCesty;
int pocetSpawnov;

// pominutelny stav
set<int> prirodzeneVlny;
vector<Utocnik> asiPridu;
map<int,int> naposledyKtoMaKolko;
int bojimSaTypu;



// pomocna funkcia. volajte zo zistiTah(), napr.:
// if (!vykonaj(Prikaz::stavaj(10, 10, VEZA_LASER))) { /* zeby malo dreva? */ }
bool vykonaj(const Prikaz& p) {
  bool uspech = vykonajPrikaz(mapa, stav, 0, p);
  if (uspech) prikazy.push_back(p);   // potom to posleme serveru
  return uspech;
}


void odsimulujKolo2(const Mapa& mapa, Stav& stav, const vector<Odpoved>& akcie) {
  // nerobime dist

fprintf(stderr, "Q");
  for (int i = 0; i < mapa.pocetHracov; i++) {
    FOREACH(it, akcie[i]) {
      vykonajPrikaz(mapa, stav, i, *it);
    }
  }

fprintf(stderr, "W");
  for (int i = 0; i < mapa.pocetHracov; i++) {
    for (unsigned j = 0; j < stav.hraci[i].utocnici.size(); j++) {
      if (j % 100 == 0 && j) fprintf(stderr, "-");
      odsimulujUtocnika(mapa, stav, dist, i, j);
    }
  }

fprintf(stderr, "E");
  for (int i = 0; i < mapa.pocetHracov; i++) {
    odsimulujPrehru(mapa, stav, dist, i);
  }

fprintf(stderr, "R");
  for (int i = 0; i < mapa.pocetHracov; i++) {
    for (unsigned j = 0; j < stav.hraci[i].veze.size(); j++) {
      odsimulujVezu(mapa, stav, dist, i, j);
    }
  }

fprintf(stderr, "T");
  FOREACH(ph, stav.hraci) {
    FOREACH(pv, ph->veze) {
      pv->terazTahala = 0;
      vector<int> noveBonusy;
      FOREACH(pb, pv->levelBonusy) (*pb)--;
      pv->levelBonusy.erase(remove(pv->levelBonusy.begin(), pv->levelBonusy.end(), 0), pv->levelBonusy.end());
    }

    FOREACH(pu, ph->utocnici) {
      if (pu->kolkoSpomaleny) pu->kolkoSpomaleny--;
    }

    FOREACH(pu, ph->prichadzajuci) {
      pu->pohybovyTimer -= kUtocnikRychlost[pu->typ];
      if (pu->pohybovyTimer >= 0) continue;
      pu->pohybovyTimer += 100;

      // spawnujeme prijdeneho ucastnika
      vector<pair<int,int> > spawnPolia;
      for (int y = 0; y < mapa.h; y++) for (int x = 0; x < mapa.w; x++) {
        if (mapa.zisti(x, y) == MAPA_SPAWN) spawnPolia.push_back(make_pair(x, y));
      }
      if (!spawnPolia.size()) return;
      pair<int,int> ktory = spawnPolia[rand() % spawnPolia.size()];
      pu->x = ktory.first;
      pu->y = ktory.second;
      ph->utocnici.push_back(*pu);
      ERASE(ph->prichadzajuci, *pu);
      --pu;
    }

    ph->drevo += kPrisunDrevaZaklad;
    if (!ph->umrel) ph->body += kVydrzoveBody;
  }

  if (stav.cas && stav.cas % kPeriodaPrirodnychUtokov == 0) {
    int typ = rand() % UTOCNIK_POCET_TYPOV;
    int n = (stav.cas / kPeriodaPrirodnychUtokov);
    int level = n * n + n - 1;
    for (int i = 0; i < mapa.pocetHracov; i++) if (!stav.hraci[i].umrel) {
      vysliUtocnikov(stav, -1, i, typ, level);
    }
  }
fprintf(stderr, "Y");

  stav.cas++;
}


template<class T> unsigned najdiXy(const vector<T>& v, int x, int y) {
  for (unsigned i = 0; i < v.size(); i++) if (v[i].x == x && v[i].y == y) return i;
  return v.size();
}


static void spravBfs(const Mapa& mapa, vector<int>& dist) {
  dist.clear();
  dist.resize(mapa.w * mapa.h, mapa.w * mapa.h * 2);
  queue<int> Q;
  for (int y = 0; y < mapa.h; y++) for (int x = 0; x < mapa.w; x++) {
    if (mapa.zisti(x, y) == MAPA_CIEL) {
      Q.push(y * mapa.w + x);
      dist[y * mapa.w + x] = 0;
    }
  }
  while (!Q.empty()) {
    int p = Q.front(); Q.pop();
    int y = p / mapa.w, x = p % mapa.w;
    for (int d = 0; d < 4; d++) {
      int ny = y + DY[d], nx = x + DX[d];
      int np = ny * mapa.w + nx, nd = dist[p] + 1;
      if (!mapa.priechodne(nx, ny)) continue;
      if (dist[np] <= nd) continue;
      dist[np] = nd;
      Q.push(np);
    }
  }
}


int pocetVezi(int typ) {
  int result = 0;
  FOREACH(it, JA.veze) if (it->typ == typ) result++;
  return result;
}


// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
  fprintf(stderr, "inicializuj\n");
  srand(time(NULL) * getpid());

  mapaJedenHrac = mapa;
  mapaJedenHrac.pocetHracov = 1;

  spravBfs(mapa, dist);
  pocetSpawnov = 0;

  for (int y = 0; y < mapa.h; y++) for (int x = 0; x < mapa.w; x++) {
    if (mapa.zisti(x, y) == MAPA_SPAWN) pocetSpawnov++;
    if (mapa.priechodne(x, y)) polickaCesty.push_back(make_pair(-dist[y*mapa.w+x], make_pair(x, y)));
  }
  sort(polickaCesty.begin(), polickaCesty.end());

  mapaprob.resize(mapa.w * mapa.h);
  FOREACH(it, polickaCesty) {
    int x = it->second.first, y = it->second.second;
    if (mapa.zisti(x, y) == MAPA_SPAWN) mapaprob[y*mapa.w+x] += 1.0/pocetSpawnov;
    int pocetPriechodnych = 0;
    for (int d = 0; d < 4; d++) {
      int nx = x + DX[d], ny = y + DY[d];
      if (mapa.priechodne(nx, ny) && dist[ny*mapa.w+nx] < dist[y*mapa.w+x]) pocetPriechodnych++;
    }
    for (int d = 0; d < 4; d++) {
      int nx = x + DX[d], ny = y + DY[d];
      if (mapa.priechodne(nx, ny) && dist[ny*mapa.w+nx] < dist[y*mapa.w+x]) {
        mapaprob[ny*mapa.w+nx] += mapaprob[y*mapa.w+x] / pocetPriechodnych;
      }
    }
    if (mapa.zisti(x, y) == MAPA_CIEL) mapaprob[y*mapa.w+x] = 0;
  }

  for (int y = 0; y < mapa.h; y++) for (int x = 0; x < mapa.w; x++) if (mapa.zisti(x, y) == MAPA_POZEMOK) {
    double okolie = 0;
    for (int d = 0; d < 4; d++) {
      int nx = x + DX[d], ny = y + DY[d];
      if (mapa.priechodne(nx, ny)) okolie += mapaprob[ny*mapa.w+nx];
    }
    dobrePozemky.push_back(make_pair(okolie, make_pair(x, y)));
  }
  sort(dobrePozemky.begin(), dobrePozemky.end());
}


bool moznoPostavDedincana() {
  int terazded = pocetVezi(VEZA_ZBERAC);
  if ( !( terazded <= 2 || stav.cas > 80 + terazded * terazded * kTerazded2 )) return false;
  if (JA.drevo - zistiCenuVeze(stav, 0, VEZA_ZBERAC) < kRezervaDreva) return false;
  FOREACH(it, dobrePozemky) {
    int x = it->second.first, y = it->second.second;
    if (vykonaj(Prikaz::buduj(x, y, VEZA_ZBERAC))) return true;
  }
  return false;
}


void extrapolujVlnu(const Utocnik& f) {
  int pocetSkupin = (kUtokPocet0P[f.typ] + f.level * kUtokPocet1P[f.typ]) / 100;
  for (int i = 1; i < pocetSkupin; i++) {
    Utocnik u;
    u.x = u.y = -1;
    u.typ = f.typ;
    u.hp = kUtocnikHp0[f.typ] + f.level * kUtocnikHp1[f.typ];
    u.ktorehoHraca = f.ktorehoHraca;
    u.level = f.level;
    u.pohybovyTimer = f.pohybovyTimer - 100 + i * kUtokRozostupy[f.typ];
    u.kolkoSpomaleny = 0;
    asiPridu.push_back(u);
  }
}


void hladajNoveVlny() {
  map<int,int> ktoMaKolko;
  FOREACH(it, JA.utocnici) {
    (ktoMaKolko[it->ktorehoHraca])++;
  }
  FOREACH(it, JA.utocnici) {
    if (it->ktorehoHraca == -1 && !prirodzeneVlny.count(it->level)) {
      prirodzeneVlny.insert(it->level);
      extrapolujVlnu(*it);
    }
    if (it->ktorehoHraca != -1 && ktoMaKolko[it->ktorehoHraca] == 1 &&
        mapa.zisti(it->x, it->y) == MAPA_SPAWN && naposledyKtoMaKolko[it->ktorehoHraca] == 0) {
      extrapolujVlnu(*it);
    }
  }
  naposledyKtoMaKolko = ktoMaKolko;
}


void updatujAsiPridu() {
  FOREACH(pu, asiPridu) {
    pu->pohybovyTimer -= kUtocnikRychlost[pu->typ];
    if (pu->pohybovyTimer >= 0) continue;
    ERASE(asiPridu, *pu);
    --pu;
  }
}


void odsimulujKoloBezCreepov(Stav& stav) {
//  fprintf(stderr, "(%d)", stav.cas);
  vector<Odpoved> nicNerobi(1);
  odsimulujKolo2(mapaJedenHrac, stav, nicNerobi);
  if (stav.cas % kPeriodaPrirodnychUtokov != 1) return;
  fprintf(stderr, "ajaj");
  vector<Utocnik>& pr = stav.hraci[0].prichadzajuci;
  if (pr.size() == 0) return;
  int level = pr[pr.size()-1].level;
  for (unsigned i = 0; i < pr.size(); i++) {
    if (pr[i].ktorehoHraca == -1 && pr[i].level == level) {
      pr.resize(i);
      break;
    }
  }
  fprintf(stderr, "jaja");
}


bool tymtoTempomUmriem() {
  fprintf(stderr, "tymtoTempomUmriem?\n");
  Stav simulacia = stav;
//  Stav staraSimulacia = stav;
  simulacia.hraci.resize(1);
  simulacia.hraci[0].prichadzajuci = asiPridu;
  int pocitadlo = 0;
  while (true) {
    if ((++pocitadlo) >= 500) {
      bojimSaTypu = random () % UTOCNIK_POCET_TYPOV;
      return true;   // neviem posudit, radsej sa branim
    }
    fprintf(stderr, ".");
    if (simulacia.hraci[0].umrel) {
//      fprintf(stderr, "Y\n");
      return true;
    }
    if (simulacia.hraci[0].utocnici.size() == 0 && simulacia.hraci[0].prichadzajuci.size() == 0) {
//      fprintf(stderr, "N\n");
      return false;
    }
//    staraSimulacia = simulacia;
    odsimulujKoloBezCreepov(simulacia);
    FOREACH(it, simulacia.hraci[0].utocnici) {
      if (dist[it->y*mapa.w+it->x] == 1) bojimSaTypu = it->typ;
    }
  }
}


bool stavajObranu(bool ibaBojim) {
  fprintf(stderr, "stavajObranu\n");
  vector<double> totalprob;
  totalprob.resize(mapa.w * mapa.h);
  vector<vector<double> > mojprobs(UTOCNIK_POCET_TYPOV);

  for (int utyp = 0; utyp < UTOCNIK_POCET_TYPOV; utyp++) {
    vector<double>& mojprob = mojprobs[utyp];
    mojprob.resize(mapa.w * mapa.h);
if (ibaBojim && utyp != bojimSaTypu) continue;
    map<pair<int,int>,double> kdeSuUtocnici;
    FOREACH(pu, JA.utocnici) {
      if (pu->typ == utyp) kdeSuUtocnici[make_pair(pu->x, pu->y)]++;
    }
    int kolkoIchPrichadza = 0;
    FOREACH(pu, asiPridu) if (pu->typ == utyp) kolkoIchPrichadza++;

    FOREACH(it, polickaCesty) {
      int x = it->second.first, y = it->second.second;
      if (mapa.zisti(x, y) == MAPA_SPAWN) mojprob[y*mapa.w+x] += 1.0*kolkoIchPrichadza/pocetSpawnov;
      mojprob[y*mapa.w+x] += kdeSuUtocnici[make_pair(x, y)];
      int pocetPriechodnych = 0;
      for (int d = 0; d < 4; d++) {
        int nx = x + DX[d], ny = y + DY[d];
        if (mapa.priechodne(nx, ny) && dist[ny*mapa.w+nx] < dist[y*mapa.w+x]) pocetPriechodnych++;
      }
      for (int d = 0; d < 4; d++) {
        int nx = x + DX[d], ny = y + DY[d];
        if (mapa.priechodne(nx, ny) && dist[ny*mapa.w+nx] < dist[y*mapa.w+x]) {
          mojprob[ny*mapa.w+nx] += mojprob[y*mapa.w+x] / pocetPriechodnych;
        }
      }
      if (mapa.zisti(x, y) == MAPA_CIEL) mojprob[y*mapa.w+x] = 0;
//      fprintf(stderr, "utocnik %d x %d y %d -> mojprob = %f\n", utyp, x, y, mojprob[y*mapa.w+x]);
    }
    for (int i = 0; i < mapa.w * mapa.h; i++) totalprob[i] += mojprob[i];
  }

  vector<pair<double,pair<int,int> > > dobrePozemky2;
  for (int y = 0; y < mapa.h; y++) for (int x = 0; x < mapa.w; x++) if (mapa.zisti(x, y) == MAPA_POZEMOK) {
    double okolie = 0;
    for (int d = 0; d < 4; d++) {
      int nx = x + DX[d], ny = y + DY[d];
      if (mapa.priechodne(nx, ny)) okolie += totalprob[ny*mapa.w+nx];
    }
//    fprintf(stderr, "pozemok %d,%d ma okolie %f\n", x, y, okolie);
    dobrePozemky2.push_back(make_pair(-okolie, make_pair(x, y)));
  }
  sort(dobrePozemky2.begin(), dobrePozemky2.end());

  int obrany[] = { VEZA_LIENKY, VEZA_PLACACKA, VEZA_CARY, VEZA_POSTREK, VEZA_SIPY };
  FOREACH(it, dobrePozemky2) {
    int x = it->second.first, y = it->second.second;
    if (najdiXy(JA.veze, x, y) != JA.veze.size()) continue;
    fprintf(stderr, "idem stavat na %d,%d\n", x, y);
    vector<pair<pair<double,int>,int> > tuto(UTOCNIK_POCET_TYPOV);
    for (int utyp = 0; utyp < UTOCNIK_POCET_TYPOV; utyp++) {
      double okolie = 0;
      for (int d = 0; d < 4; d++) {
        int nx = x + DX[d], ny = y + DY[d];
        if (mapa.priechodne(nx, ny)) okolie += mojprobs[utyp][ny*mapa.w+nx];
      }
      fprintf(stderr, "utocnikov %d tam bude %f\n", utyp, okolie);
      tuto[utyp] = make_pair(make_pair(-okolie, rand()), utyp);
    }
    sort(tuto.begin(), tuto.end());
    for (int i = 0; i < UTOCNIK_POCET_TYPOV; i++) {
      int utyp = tuto[i].second;
      if (vykonaj(Prikaz::buduj(x, y, obrany[utyp]))) return true;
      if (utyp == UTOCNIK_HUSENICA && vykonaj(Prikaz::buduj(x, y, VEZA_LASER))) return true;
//      return false;   ////////// TODO! toto mozno chceme?
    }
  }

  return false;
}


void skusmeUtocit() {
  // TODO
}


void skusmeLaboratoria() {
  // TODO
}


// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat
void zistiTah() {
  fprintf(stderr, "---%d---\n", stav.cas);
  while (moznoPostavDedincana()) { }
  hladajNoveVlny();
  while (tymtoTempomUmriem() && (stavajObranu(true) || stavajObranu(false))) { }
  skusmeUtocit();
  skusmeLaboratoria();
  updatujAsiPridu();
}


int main() {
  // v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

  nacitaj(cin, mapa);
  inicializuj();

  while (cin.good()) {
    nacitaj(cin, stav);
    prikazy.clear();
    zistiTah();
    uloz(cout, prikazy);
    cout << ".\n" << flush;   // bodka a flush = koniec odpovede
  }

  return 0;
}

